#/bin/sh
#
# AzBox HD SwapOn v1.0 for OpenXCAS
# (c) by monkus (mooncusz@gmail.com)
# 
# 1.0 
# - new plugin to add more total memory using swap
# - possible to choose swap device (usb device or internal hard disk)
# - possible to choose swap size (100MB is fine)
# - compatibility with azbox webinterface (by DEDEX7200Pro. Original from joseba and koivo)

DD=/bin/dd
FREE=/usr/bin/free
GREP=/bin/grep
MKSWAP=/sbin/mkswap
MOUNT=/bin/mount
SED=/bin/sed
SWAPON=/sbin/swapon
WEBIF=$1
read SWAPDEVICE </MMP/httpd/configs/swap.conf

# choose device, where to create swapfile
#SWAPDEVICE=/DATA/hdb1
#SWAPDEVICE=/DATA/usb1/sda1

SWAPFILE=swapfile
SWAPSIZE=102400

web_variables () {                                                                                                                                                   
 if [ "$WEBIF" = "webif" ]
    then
      echo Using variables from web interface
      read SWAPDEVICE </MMP/httpd/configs/swap.conf
      exit 1 
  fi
}  

check_device () {                                                              
  $MOUNT$GREP $SWAPDEVICE >> /dev/null
   if [ "$?" = 1 ]; then                                                       
      echo "Device for hosting swapfile doesn't exist"
      disable_plugin                                                            
      exit 1                                                                    
   fi                                                                          
}  

check_swapfile () {
  if [ -e $SWAPDEVICE/$SWAPFILE ];
    then
      echo Using existing swapfile
    else 
      echo Creating new swapfile 
      $DD if=/dev/zero of=$SWAPDEVICE/$SWAPFILE bs=1024 count=$SWAPSIZE  
      $MKSWAP $SWAPDEVICE/$SWAPFILE
  fi 
}

add_swap () {
  $FREE 
  $SWAPON $SWAPDEVICE/$SWAPFILE 
  $FREE 
}  

disable_plugin () {
  $GREP swapon /PLUGINS/OpenXCAS/module.seq$GREP "#" >> /dev/null
  if [ $? != 0 ]; then
    $SED -i 's/swapon/\#swapon/' /PLUGINS/OpenXCAS/module.seq
  fi 
}

echo "AzBox HD SwapOn v1.1 for OpenXCAS (c) by monkus"

web_variables
check_device
check_swapfile
add_swap
disable_plugin